Layer effects having unexpected render issues in Print Composer

2016-10-12 05:59 PM - Jamie Portman

Status: Closed

Priority: Normal

Assignee: Nyall Dawson

Category: Symbology

Affected QGIS version:2.14.5 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23619

Description

Hi,

I have search a bit and can't find any previous threads or reports of this issue...

We have encountered on numerous occasions, some bizarre results in the print composer when using layer effects (particularly a drop

shadow).

Everything looks fine in the map canvas, but on refreshing the print composer, random triangles are seen (in the base color of the shadow

used... black, white, solid blue, etc.)

Frustratingly, it doesn't happen all the time on any particular layer. The screen shots attached are from a project I've been working with no

problems for nearly a month, and then today it just starts happening and the only way to get ride of it is to remove the layer effects.

Annoying, as this feature is awesome and makes the final map have a much greater impact!

If you export to PDF/JPG the additional, unwanted triangles do transfer to the final result.

The triangles in this particular layer all appear on lines that have a significant change of direction, I'm not sure if this is always the case.

Apologies, if I'm not supposed to assign a ticket to a person... this is one of very few times that I know the developer that came up with the

feature!

Associated revisions

Revision a0bfc10c - 2016-10-14 09:06 AM - Nyall Dawson

Fix bad fills when using marker line with render effects (fix #15696)

Revision 55f20710 - 2016-10-17 01:55 AM - Nyall Dawson

Always clear pen/brush before drawing layer effects (fix #15696)

Revision bec7cdd5 - 2016-10-17 06:25 AM - Nyall Dawson

Fix bad fills when using marker line with render effects (fix #15696)

(cherry-picked from a0bfc10, 55f207)

Revision 4f10a9d2 - 2016-10-17 06:53 AM - Nyall Dawson
Fix bad fills when using marker line with render effects (fix #15696)

(cherry-picked from a0bfc10, 55f207)

Revision d1aff824 - 2016-10-17 07:25 AM - Nyall Dawson

Fix bad fills when using marker line with render effects (fix #15696)

(cherry-picked from a0bfc10, 55f207)

History

#1 - 2016-10-12 07:22 PM - Nyall Dawson

Jamie -

I hit this issue once myself but unfortunately lost the project and couldn't find a way to reproduce it. Is there any chance you could share this project file?

#2 - 2016-10-12 07:46 PM - Jamie Portman

there is a LOT in the project... I'll see if I can strip it back but manage to retain the glitch!

#3 - 2016-10-13 04:10 PM - Jamie Portman

- File shadow_project.zip added

Hi Nyall,

I've managed to strip back the project and isolate when the problem occurs a fair bit!

The attached project demonstrates the issue with a single layer.

The problem only occurs when the layer is duplicated (as it is here). Only the top layer has draw effects (shadow) turned on. If the bottom layer is turned

off, the issue goes away. If the bottom layer is moved above the other layer, it also goes away!

The issue is only visible in the print composer, it always looks perfectly as expected in the map window :)

Hope this helps.

Jamie

#4 - 2016-10-13 04:20 PM - Nyall Dawson

Perfect - exactly what I needed, thank you. Looks like the issue is caused by the marker line style drawn underneath a layer with effects.

#5 - 2016-10-14 12:07 AM - Nyall Dawson

- Status changed from Open to Closed

Fixed in changeset commit:"a0bfc10c568e3e4f54a7f43ca285e2e7b11a194a".
#6 - 2016-10-14 12:17 AM - Jamie Portman

Thankyou Nyall, you are awesome!

To anyone who says "it's open source, so you just dont have the technical support of commercial software"... well, I am yet to have a bug resolved by

Mapinfo or ESRI as quickly as the QGIS developers do!

I take it this fix will flow through into both the next LR and LTR releases?

#7 - 2016-10-14 12:44 AM - Nyall Dawson

Yes, I'll backport it to the current stable releases too so it'll be in the next point releases. Just going to test a few other things first - I think there may be a

slightly better way to address this.

Files

MapComposer.JPG 30.4 KB 2016-10-12 Jamie Portman

PrintComposer-randomtrianglesrendered.JPG 17.7 KB 2016-10-12 Jamie Portman

shadow_project.zip 41.5 KB 2016-10-13 Jamie Portman
